/****************************************************************************/
/*  
**        T U L K K I . C
**
** Ohjelmalla tehdn pieni sanakirja.
** Sanasto sijaitsee tiedostossa SANASTO.DAT ja sen on oltava muotoa:
** (Turbo-C:ss sanastoa etsitn samasta hakemistosta, josta ohjelma
**  kynnistyi, muissa jrjestelmiss oletushakemistosta, ks. lue_sanasto)
** 
** Suomi        | Ruotsi         | Englanti      
** ;------------------------------------------
** min         | jag            | i
** sin         | du             | you (yks.)
** hn          | han (mask.)    | he  (mask.)
** hn          | hon (fem.)     | she (fem.)
** me           | vi             | we          
** te           | ni             | you (mon.)
** he           | dom            | they
** hernekeitto  | rtsoppa       | pea soup
** sukellusvene | ubt           | submarine
** suklaa       | chokolade      | chocolate
** sukka        | socka (lyhyt)  | sock (lyhyt)
** sukka        | strumpa (pitk)| stocking (pitk)
** 
**
** Ohjelman aluksi koko sanasto luetaan muistiin seuraavannkiseen
** tietorakenteeseen:
**
** Sanasto:
**  ----------
**  |Kieli 3|  0 1 2
**  |        |--------
**  |Lyhenteet |S|R|E|
**  |        |--------
**  |        |       0       1        2
**  |        |  -----------------------------  
**  |kielet o+->|o|Suomi  |Ruotsi  |Englanti|
**  |        |  -+---------------------------
**  |        |   |
**  |        |   v
**  |        |  -----------------------------
**  |loppu  o|  |o|min   |jag     |i       |
**  --------+-  -+---------------------------
**          |    |
**          |    v
**          |   -----------------------------
**          |   |o|sin   |du      |you     |
**          |   -+---------------------------
**          |    |
**          |    v
**          |   -----------------------------
**          --->|o|hn    |han(mask|he(mask)|
**              -+---------------------------
**               |
**               v
**              NULL
** 
** Siis sanasto on linkitetty lista, jossa alkiona on yksi sana kaikilla
** kieleill.  Sanaston yksi rivi on totetutettu osoittimina merkkijonoon
** joka on ptkitty pystyviivojen kohdalta:
**
**
**                            min jag i
**                            ^    ^   ^
**               -----        |    |   |
**  Seuraava sana| o-+--->    |    |   |
**               |---|        |    |   |
**  sanat      0 | o-+---------    |   |
**               |---|             |   |
**             1 | o-+--------------   |
**               |---|                 |
**             2 | o-+------------------
**               |---|
**
**
**
** Tmn tiedoston aliohjelmat:
**    main                   - pohjelma
**       
** Ohjelman kntmiseksi tarvittavat tiedostot:
**  tulkki.c                 - tm tiedosto
**  tulkkita.c               - sanaston lukeminen levylt
**  mjonot.c (tai mjonot.obj)- merkkijonojen ksittelyyn liittyvi apuohjelmia
**  tulkki.h                 - tmn ohjelman mritykset  
**  mjonot.h                 - mekrkijonojen mritykset
**  
**
**  Tekijt:          Vesa Lappalainen
**                    Ohjelmointikurssi 1991
**  Tehty:            6.12.1991
**  Muutettu:
**  Mit muutettu:   
**
**  Jatkosuunnitelmat:
**   - valmiiksi
*/


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "mjonot.h"
#include "tulkki.h"


int main(void)
{ 
  Sanasto_tyyppi sanasto; char *virhe;

  if ( (virhe=lue_sanasto(&sanasto)) != NULL ) {
    printf("%s\n",virhe);
    return 1;
  }

  return 0;
}
