/****************************************************************************/
/*  
**        T U L K K I . H
**
**  Tiedosto sislt TULKKI-ohjelman tarvitsemat yleiset 
**    vakiot
**    tietotyypit
**    globaalit vakiotyyliset muuttujat
**    makrot
**    aliohjelmien otsikot
**
**
**  Tekijt:          Vesa Lappalainen
**                    Ohjelmointikurssi 1991
**  Tehty:            6.12.1991
**  Muutettu:
**  Mit muutettu:   
**
*/

/****************************************************************************/
/*    
**      V a k i o t                                                           
*/

#define TURBO_C                 /* Turbo-C:n ominaisuudet (= sanast.polku)  */
#define MAX_KIELIA 10           /* Suurin sallittu kielien lukumr.       */
#define KIELIA_VALMIINA 3       /* Montako kielt taulukoissa valmiina      */
#define SANASTO "sanasto.dat"   /* Sanaston nimi levyll.                   */


/****************************************************************************/
/*    
**      T i e t o t y y p i t                                                 
**                                                                          
** Tietorakenteen kuva ks. tulkki.c
*/                                                                          


typedef struct Sanat_tyyppi { /* Yhden sanan kaikkein kieliset muodot       */ 
  struct Sanat_tyyppi *seuraava; /* Osoitin seuraavaan sanaan               */
  char   *sanat[KIELIA_VALMIINA];/* Sanat osoittimina merkkijonoihin        */ 
} Sanat_tyyppi;/* Varsinainen koko ptetn kun kielien lkm saatu selville.*/ 


typedef struct {              /* Sanaston ylin osa.                         */
  int kielia;                    /* Eri kielien lukumr sanastossa.       */
  char lyhenteet[MAX_KIELIA+1];  /* Kielien lyhenteet                       */
  Sanat_tyyppi *kielet;          /* Osoitin taulukkoon jossa kielien nimet  */
  Sanat_tyyppi *loppu;           /* Osoitin sanaston viimeiseen sanaan      */
} Sanasto_tyyppi;


/****************************************************************************/
/*    
**      G l o b a a l i t (vakio!) muuttujat                                  
*/

/****************************************************************************/
/*  
**      M A K R O T                                                             
*/

/****************************************************************************/
/*  
**      A L I O H J E L M A T                                                   
**
** Aliohjelmia on seuraavissa tiedostoissa:
**  tulkkita.c   - sanaston lukeminen
**    lue_sanasto            - lukee sanaston levylt
*/

char *lue_sanasto(Sanasto_tyyppi *);

