/****************************************************************************/
/*  
**        T U L K K I . C
**
** Ohjelmalla tehdn pieni sanakirja.
** Sanasto sijaitsee tiedostossa SANASTO.DAT ja sen on oltava muotoa:
** (Turbo-C:ss sanastoa etsitn samasta hakemistosta, josta ohjelma
**  kynnistyi, muissa jrjestelmiss oletushakemistosta, ks. lue_sanasto)
** 
** Suomi        | Ruotsi         | Englanti      
** ;------------------------------------------
** min         | jag            | i
** sin         | du             | you (yks.)
** hn          | han (mask.)    | he  (mask.)
** hn          | hon (fem.)     | she (fem.)
** me           | vi             | we          
** te           | ni             | you (mon.)
** he           | dom            | they
** hernekeitto  | rtsoppa       | pea soup
** sukellusvene | ubt           | submarine
** suklaa       | chokolade      | chocolate
** sukka        | socka (lyhyt)  | sock (lyhyt)
** sukka        | strumpa (pitk)| stocking (pitk)
** 
**
** Ohjelman aluksi koko sanasto luetaan muistiin seuraavannkiseen
** tietorakenteeseen:
**
** Sanasto:
**  ----------
**  |Kieli 3|  0 1 2
**  |        |--------
**  |Lyhenteet |S|R|E|
**  |        |--------
**  |        |       0       1        2
**  |        |  -----------------------------  
**  |kielet o+->|o|Suomi  |Ruotsi  |Englanti|
**  |        |  -+---------------------------
**  |        |   |
**  |        |   v
**  |        |  -----------------------------
**  |loppu  o|  |o|min   |jag     |i       |
**  --------+-  -+---------------------------
**          |    |
**          |    v
**          |   -----------------------------
**          |   |o|sin   |du      |you     |
**          |   -+---------------------------
**          |    |
**          |    v
**          |   -----------------------------
**          --->|o|hn    |han(mask|he(mask)|
**              -+---------------------------
**               |
**               v
**              NULL
** 
** Siis sanasto on linkitetty lista, jossa alkiona on yksi sana kaikilla
** kieleill.  Sanaston yksi rivi on totetutettu osoittimina merkkijonoon
** joka on ptkitty pystyviivojen kohdalta:
**
**
**                            min jag i
**                            ^    ^   ^
**               -----        |    |   |
**  Seuraava sana| o-+--->    |    |   |
**               |---|        |    |   |
**  sanat      0 | o-+---------    |   |
**               |---|             |   |
**             1 | o-+--------------   |
**               |---|                 |
**             2 | o-+------------------
**               |---|
**
**
**
** Ohjelmaa voidaan mys kutsua komentorivilt muodossa:
**  >tulkki sukka/s-e
**
** Tmn tiedoston aliohjelmat:
**    alkuohjeet             - tuloistaa ohjelman alussa olevat ohjeet
**    ohjeet                 - tulostaa varsinaiset kyttohjeet
**    tulkkaa                - suorittaa tulkkauksen
**    main                   - pohjelma
**       
** Ohjelman kntmiseksi tarvittavat tiedostot:
**  tulkki.c                 - tm tiedosto
**  tulkkita.c               - sanaston lukeminen levylt
**  tulkkiet.c               - sanastosta etsiminen
**  mjonot.c (tai mjonot.obj)- merkkijonojen ksittelyyn liittyvi apuohjelmia
**  tulkki.h                 - tmn ohjelman mritykset  
**  mjonot.h                 - mekrkijonojen mritykset
**  
**
**  Tekijt:          Vesa Lappalainen
**                    Ohjelmointikurssi 1991
**  Tehty:            6.12.1991
**  Muutettu:
**  Mit muutettu:   
**
**  Jatkosuunnitelmat:
**   - tulostusjrjestyksen olisi ehk parempi tulostaa ensin yksi
**     kieli kokonaan ja vasta sitten vaihtaa toiseen kieleen.
**     Nyt tulostetaan sanaston yksi rivi kerrallaan ja tm oli
**     alkuperisess suunnitelmassa.  Muutos olisi helppo, sill
**     vaihdettaisiin vain silmukoiden jrjestyst aliohjelmassa
**     tulosta_kaannos
**   - parempi tietorakenne tilan sstmiseksi
**   - kytt suoraan levylt, jolloin sanasto voisi olla suurempi
*/


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "mjonot.h"
#include "tulkki.h"

/****************************************************************************/
void                      /*                                                */
alkuohjeet(               /*                                                */
  Sanasto_tyyppi *sanasto,/* s   Sanasto josta tulkataan.                   */
  Kaannos_tyyppi *kaannos /* s   Alkuperinen knnsohje                   */
)    
/* 
** Funktiolla tulostetaan ohjelman kynnistyksess tulevat ohjeet.
** Tulostus:  Nyttn
----------------------------------------------------------------------------*/
{
  int i;
  printf(
    "Terve! Olen Satunnaiselle matkaajalle suunniteltu Tulkki!\n"
    "Sanastoni on tiedostossa "SANASTO".  Mikli haluat list\n"
    "sanastoa, kyt tekstinksittelyohjelmaa sanaston\n"
    "pivittmiseksi.\n"
    "\n"
    "Avustusta saat vastaamalla ? kun sinulta kysytn sanaa.\n"
    "Tulkattavina kielin on nyt "
  );
  for (i=0; i<kaannos->mista.lkm; i++)
    printf("%s ",sanasto->kielet->sanat[kaannos->mista.kielet[i]]);
  printf("- ");
  for (i=0; i<kaannos->mihin.lkm; i++)
    printf("%s ",sanasto->kielet->sanat[kaannos->mihin.kielet[i]]);
  printf("\n");
}


/****************************************************************************/
void                      /*                                                */
ohjeet(                   /*                                                */
  Sanasto_tyyppi *sanasto /* s   Sanasto josta tulkataan.                   */
)    
/* 
** Funktiolla tulostetaan ohjelman kyttohjeet.
** Tulostus:  Nyttn
----------------------------------------------------------------------------*/
{
  int i;
  printf(
    "-------------------------------------------------------------\n"
    "Avustus:\n"
    "\n"
    "Kirjoita sanakysymyksen pern sana jonka haluat knt.\n"
    "Mikli painat pelkn [RET], ohjelman toiminta loppuu.\n"
    "\n"
    "Mikli haluat vaihtaa kieli, kirjoita sanan pern\n"
    "kauttaviiva ja kielten nimien lyhennekirjaimet, joita \n"
    "haluat knt.  Mikli haluat knnksen samalla \n"
    "usealle eri kielelle/kielelt, kirjoita kaikki haluamasi \n"
    "kielet.  Mikli haluat knnksen kaikille mahdollisille\n"
    "kielille, kirjoita vain lhtkieli.\n"
    "\n"
    "Tunnen kielet"
  );
  for (i=0; i<sanasto->kielia; i++) printf(" %s",sanasto->kielet->sanat[i]);
  printf(".\n"
    "Esimerkki: \n"
    "Sana>kissa/s-e\n"
    "suomi: kissa = englanti: cat\n"
    "Sana>car\n"
    "englanti: car = suomi: auto\n"
    "Sanassa voi kytt mys jokerimerkkej * ja ?\n"
    "Esimerkki:\n"
    "Sana>suk*\n"
    "--------------------------------------------------------------\n"
  );
}


/****************************************************************************/
void                      /*                                                */
tulkkaa(                  /*                                                */
  Sanasto_tyyppi *sanasto,/* s   Sanasto josta tulkataan.                   */
  char *jono             ,/* s   Tulkattava jono.                           */
  Kaannos_tyyppi *kaannos /* s,t Alkuperinen knnsohje                   */
)    
/* 
** Funktiolla kysytn aina sana ja etsitn sit vastaavat knnkset
** sanastosta.  Lopetetaan kun painetaan pelkk RET.
**
** Muuttuu:   jono  
** Sytt:    Ptteelt
** Tulostus:  Nyttn
** Kutsuu:    lue_jono
**            ohjeet
**            muuta_kaannos
**            tulosta_kaannos
----------------------------------------------------------------------------*/
{
  if ( strcmp(jono,"?")==0 ) { 
    ohjeet(sanasto);  
    return;
  }
  muuta_kaannos(kaannos,jono,sanasto->lyhenteet);
  if (*jono) tulosta_kaannos(sanasto,jono,kaannos);
}


int main(int argc, char *argv[])
{
  int i;
  Sanasto_tyyppi sanasto;
  char *lyhenteet=sanasto.lyhenteet;
  Kaannos_tyyppi kaannos;
  char *virhe; /*01234*/
  char jono[80]="/s-r";

  if ( (virhe=lue_sanasto(&sanasto,argv[0])) != NULL ) {
    printf("%s\n",virhe);
    return 1;
  }

  /* Aluksi oletusknns: */
  jono[1] = lyhenteet[0];  jono[3] = lyhenteet[1];
  muuta_kaannos(&kaannos,jono,lyhenteet);


  if (argc<=1) /* argv[0] on ohjelman oma nimi!                             */
    alkuohjeet(&sanasto,&kaannos);
  else {
    jono[0]=0;
    for (i=1; i<argc; i++) liita_jono(N_S(jono),argv[i]);
    tulkkaa(&sanasto,jono,&kaannos);
  }

  while (1) {
    printf("Sana>");
    if ( lue_jono(N_S(jono)) <= OLETUS ) break;
    tulkkaa(&sanasto,jono,&kaannos);
  }

  return 0;
}
