/****************************************************************************/
/*  
**        T U L K K I . H
**
**  Tiedosto sislt TULKKI-ohjelman tarvitsemat yleiset 
**    vakiot
**    tietotyypit
**    globaalit vakiotyyliset muuttujat
**    makrot
**    aliohjelmien otsikot
**
**
**  Tekijt:          Vesa Lappalainen
**                    Ohjelmointikurssi 1991
**  Tehty:            6.12.1991
**  Muutettu:
**  Mit muutettu:   
**
*/

/****************************************************************************/
/*    
**      V a k i o t                                                           
*/

#ifdef __TURBOC__
# define TURBO_C                /* Turbo-C:n ominaisuudet (= sanast.polku)  */
#endif
#define MAX_KIELIA 10           /* Suurin sallittu kielien lukumr.       */
#define KIELIA_VALMIINA 3       /* Montako kielt taulukoissa valmiina      */
#define SANASTO "sanasto.dat"   /* Sanaston nimi levyll.                   */


/****************************************************************************/
/*    
**      T i e t o t y y p i t                                                 
**                                                                          
** Tietorakenteen kuva ks. tulkki.c
*/                                                                          


typedef struct Sanat_tyyppi { /* Yhden sanan kaikkein kieliset muodot       */ 
  struct Sanat_tyyppi *seuraava; /* Osoitin seuraavaan sanaan               */
  char   *sanat[KIELIA_VALMIINA];/* Sanat osoittimina merkkijonoihin        */ 
} Sanat_tyyppi;/* Varsinainen koko ptetn kun kielien lkm saatu selville.*/ 


typedef struct {              /* Sanaston ylin osa.                         */
  int kielia;                    /* Eri kielien lukumr sanastossa.       */
  char lyhenteet[MAX_KIELIA+1];  /* Kielien lyhenteet                       */
  Sanat_tyyppi *kielet;          /* Osoitin taulukkoon jossa kielien nimet  */
  Sanat_tyyppi *loppu;           /* Osoitin sanaston viimeiseen sanaan      */
} Sanasto_tyyppi;


typedef struct {              /* Knnksess tarvittava mist minne tyyppi */
  int lkm;                       /* Montako alkiota on kytetty.            */
  int kielet[MAX_KIELIA];        /* Taulukko kielist (tai niiden ind).     */
} Kielet_tyyppi;


typedef struct {              /* Mist mihin tyyppi.                        */
  Kielet_tyyppi mista;        /* Mist kielist knnetn?                 */
  Kielet_tyyppi mihin;        /* Mihin kieliin knnetn?                  */
} Kaannos_tyyppi;

/****************************************************************************/
/*    
**      G l o b a a l i t (vakio!) muuttujat                                  
*/

/****************************************************************************/
/*  
**      M A K R O T                                                             
*/

/****************************************************************************/
/*  
**      A L I O H J E L M A T                                                   
**
** Aliohjelmia on seuraavissa tiedostoissa:
**  tulkkita.c   - sanaston lukeminen
**    lue_sanasto            - lukee sanaston levylt
**  tulkkiet.c   - sanastosta etsiminen
**    muuta_kaannos          - muuttaa muodon "sana/s-r" tarvittavaan muotoon
**    tulosta_kaannos        - tulostaa vastinsanat sanastosta
*/

char *lue_sanasto(Sanasto_tyyppi *,char *);

int muuta_kaannos(Kaannos_tyyppi *,char *,char *);
void tulosta_kaannos(Sanasto_tyyppi *,char *,Kaannos_tyyppi *);
